package com.malk.lanyun.Mapper;

import com.malk.lanyun.entity.ProjectAnalysis;
import org.springframework.jdbc.core.RowMapper;

import java.sql.ResultSet;
import java.sql.SQLException;


public class ProjectAnalysisMapper implements RowMapper<ProjectAnalysis> {
    @Override
    public ProjectAnalysis mapRow(ResultSet resultSet, int i) throws SQLException {
        ProjectAnalysis projectAnalysis = new ProjectAnalysis();
        projectAnalysis.setProjectName(resultSet.getString("project_name"));
//        projectAnalysis.setBelongProject(resultSet.getString("belong_name"));
        projectAnalysis.setMonth(resultSet.getString("month"));
//        projectAnalysis.setStatus(resultSet.getString("status"));
//        projectAnalysis.setDLevel(resultSet.getString("d_level"));
        projectAnalysis.setPredictIncome(resultSet.getBigDecimal("predict_income"));
        projectAnalysis.setOpen(resultSet.getBigDecimal("open"));
        projectAnalysis.setIncome(resultSet.getBigDecimal("income"));
        projectAnalysis.setPerson(resultSet.getBigDecimal("person"));
        projectAnalysis.setPersonCost(resultSet.getBigDecimal("person_cost"));
        projectAnalysis.setMaterial(resultSet.getBigDecimal("material"));
        projectAnalysis.setOtherCost(resultSet.getBigDecimal("other_cost"));
        projectAnalysis.setCostSum(resultSet.getBigDecimal("cost_sum"));
        projectAnalysis.setTaxes(resultSet.getBigDecimal("taxes"));
        projectAnalysis.setGrossProfit(resultSet.getBigDecimal("gross_profit"));
        projectAnalysis.setGrossMargin(resultSet.getString("gross_margin"));
        projectAnalysis.setOverhead(resultSet.getBigDecimal("overhead"));
        projectAnalysis.setCorporateIncomeTax(resultSet.getBigDecimal("corporate_income_tax"));
        projectAnalysis.setNetProfit(resultSet.getBigDecimal("net_profit"));
        projectAnalysis.setNetMargin(resultSet.getString("net_margin"));
//        projectAnalysis.setFormat(resultSet.getString("format"));
//        projectAnalysis.setCustomerSystem(resultSet.getString("customer_system"));
//        projectAnalysis.setProfitLoss(resultSet.getString("profit_loss"));
//        projectAnalysis.setApproachDate(resultSet.getString("approach_date"));
//        projectAnalysis.setLevel(resultSet.getString("level"));
//        projectAnalysis.setNotes(resultSet.getString("notes"));

        return projectAnalysis;
    }
}
