package com.malk.lanyun.service.impl;


import com.malk.lanyun.service.DingTalkService;
import com.malk.server.dingtalk.DDConf;
import com.malk.server.dingtalk.DDR;
import com.malk.server.dingtalk.DDR_New;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
@Slf4j
public class DingTalkServiceImpl implements DingTalkService {


    @Override
    public Map getAllUserIdInfo(String access_token, String status_list, Number offset, Number size) {
        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("status_list, offset, size", status_list, offset,size);
        return (Map) DDR.doPost("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/queryonjob", null, param, body).getResult();
    }

    @Override
    public List<Map> getDDUserInfoById(String access_token, String userId, Number appAgentId) {
        Map param = UtilMap.map("access_token", access_token);
        Map body = UtilMap.map("userid_list, agentid", userId, appAgentId);
        return (List<Map>) DDR.doPost("https://oapi.dingtalk.com/topapi/smartwork/hrm/employee/v2/list", null, param, body).getResult();
    }

}
