package com.malk.lanyun.service.impl;

import cn.hutool.core.util.ArrayUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.malk.lanyun.entity.MySqlBean;
import com.malk.lanyun.entity.SqlServerBean;
import com.malk.lanyun.service.NCService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.service.aliwork.YDClient;
import com.malk.service.aliwork.YDService;
import com.malk.utils.UtilDateTime;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.*;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
@Slf4j
public class NCServiceImpl implements NCService {

    @Autowired
    private YDClient ydClient;

    @Autowired
    private SqlServerBean sqlBean;
    @Autowired
    private MySqlBean mySqlBean;
    @Autowired
    private YDService ydService;

    // 获取当前日期
    LocalDate lastMonth = LocalDate.now().minusMonths(1);
    //本月
//    LocalDate lastMonth = LocalDate.now();
    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
    @Override
    public void getNcInfo() {
        // 获取上月年，月
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-D7FAD41DA72041ED96431F4219F082B7DTNH","textField_m0dkzhwo", String.valueOf(year),month);

        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());
            // 创建 Statement 对象
            statement = connection.createStatement();

            // 执行查询
            String sql = "SELECT b.adjustperiod AS adjustperiod, b.pk_accasoa AS pk_accasoa, a.name AS accasoa_name, SUM ( b.creditamount ) AS creditamount             FROM gl_detail b JOIN bd_accasoa a ON b.pk_accasoa = a.pk_accasoa WHERE  b.yearv = "+year+"\n AND b.adjustperiod = "+ month +
                    "            AND b.accountcode IN ( '50010101', '500102', '500103', '500117', '500114', '500115', '500118', '500119', '500109', '500133' )             AND b.pk_accountingbook IN ( SELECT pk_accountingbook FROM org_accountingbook WHERE code IN ( 'A01-0004', 'A02-0004', 'A03-0004', 'A04-0004', 'A05-0004', 'A06-0004', 'A10-0004', 'A11-0004' ) )             GROUP BY b.adjustperiod,  b.pk_accasoa, a.name";

            resultSet = statement.executeQuery(sql);

            // 处理结果集
            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+resultSet.getString("adjustperiod");
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("pk_accasoa"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("accasoa_name"));
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("creditamount"));

                log.info("yearv："+UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                log.info("periodv："+resultSet.getString("pk_accasoa"));
                log.info("periodv："+resultSet.getString("accasoa_name"));
                log.info("creditamount："+resultSet.getBigDecimal("creditamount"));

                //写入月度项目经营情况
                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-D7FAD41DA72041ED96431F4219F082B7DTNH")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getNcCgInfo() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-EC67BCB875264EE9AE25C9D663568CAFCYU6","textField_m0dkzhwo", String.valueOf(year),month);

        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "SELECT b.adjustperiod AS adjustperiod, b.pk_accasoa AS pk_accasoa,a.name AS accasoa_name, SUM ( b.creditamount ) AS creditamount             FROM gl_detail b JOIN bd_accasoa a ON b.pk_accasoa = a.pk_accasoa WHERE b.yearv = "+year+" AND b.adjustperiod = "+ month +
                    "            AND b.accountcode IN ( '500114', '500115' )             AND b.pk_accountingbook IN ( SELECT pk_accountingbook FROM org_accountingbook WHERE code IN ( 'A01-0004', 'A02-0004', 'A03-0004', 'A04-0004', 'A05-0004', 'A06-0004', 'A10-0004', 'A11-0004' ))             GROUP BY b.adjustperiod,  b.pk_accasoa,  a.name";


            resultSet = statement.executeQuery(sql);

            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+resultSet.getString("adjustperiod");
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("pk_accasoa"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("accasoa_name"));
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("creditamount"));

                log.info("yearv："+UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                log.info("periodv："+resultSet.getString("pk_accasoa"));
                log.info("periodv："+resultSet.getString("accasoa_name"));
                log.info("creditamount："+resultSet.getBigDecimal("creditamount"));

                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-EC67BCB875264EE9AE25C9D663568CAFCYU6")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();

        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * 大业主项目
     */
    @Override
    public void getNcCost() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-87BF51F1E54D4D73A987939613D07BD5ZZE9","textField_m0dkzhwo", String.valueOf(year),month);

        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "SELECT b.adjustperiod AS adjustperiod, b.pk_accasoa AS pk_accasoa,a.name AS accasoa_name, SUM ( b.creditamount ) AS creditamount             FROM gl_detail b JOIN bd_accasoa a ON b.pk_accasoa = a.pk_accasoa WHERE b.yearv = "+year+" AND b.adjustperiod = "+ month +
                    "            AND b.accountcode IN ( '500114', '500115' )             AND b.pk_accountingbook IN ( SELECT pk_accountingbook FROM org_accountingbook WHERE code IN ( 'A01-0004', 'A02-0004', 'A03-0004', 'A04-0004', 'A05-0004', 'A06-0004', 'A10-0004', 'A11-0004' ))             GROUP BY b.adjustperiod,  b.pk_accasoa,  a.name";


            resultSet = statement.executeQuery(sql);

            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+resultSet.getString("adjustperiod");
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("pk_accasoa"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("accasoa_name"));
                hashMap.put("textField_m0eudqp0","大业主项目ID");
                hashMap.put("textField_m0eudqp2","大业主项目名称");
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("creditamount"));

                log.info("yearv："+UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                log.info("periodv："+resultSet.getString("pk_accasoa"));
                log.info("periodv："+resultSet.getString("accasoa_name"));
                log.info("creditamount："+resultSet.getBigDecimal("creditamount"));

                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-87BF51F1E54D4D73A987939613D07BD5ZZE9")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getNcCollection() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-5654B7C22E7546E9BBE7B4EF46DE08BAXZXU","textField_m0dkzhwo", String.valueOf(year),month);

        System.out.println(month);
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "SELECT b.adjustperiod AS adjustperiod, b.pk_accasoa AS pk_accasoa,a.name AS accasoa_name, SUM ( b.creditamount ) AS creditamount             FROM gl_detail b JOIN bd_accasoa a ON b.pk_accasoa = a.pk_accasoa WHERE b.yearv = "+year+" AND b.adjustperiod = '"+ month + "'" +
                    "            AND (b.accountcode like '6602%' OR b.accountcode IN ('660101','660103','660104'))" +
                    "            AND b.pk_accountingbook IN ( SELECT pk_accountingbook FROM org_accountingbook WHERE code IN ( 'A01-0004', 'A02-0004', 'A03-0004', 'A04-0004', 'A05-0004', 'A06-0004', 'A10-0004', 'A11-0004' ))             GROUP BY b.adjustperiod,  b.pk_accasoa,  a.name";


            resultSet = statement.executeQuery(sql);

            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+resultSet.getString("adjustperiod");
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("pk_accasoa"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("accasoa_name"));
                hashMap.put("textField_m0eudqp0","部门");
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("creditamount"));

                log.info("yearv："+UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                log.info("periodv："+resultSet.getString("pk_accasoa"));
                log.info("periodv："+resultSet.getString("accasoa_name"));
                log.info("creditamount："+resultSet.getBigDecimal("creditamount"));


                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-5654B7C22E7546E9BBE7B4EF46DE08BAXZXU")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getSupplierPay() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-09CDC75CDC6048379567EC87ED6CE7B6T8PP","textField_m0g4itw4", String.valueOf(year),null);

        LocalDate firstDayOfYear = LocalDate.of(year, 1, 1);
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        String formattedBeginDate = firstDayOfYear.format(formatter);
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;

        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "EXECUTE GetAccountDetails  @IncrementFlag = 0, @BeginDate ='"+formattedBeginDate+"'  ";


            resultSet = statement.executeQuery(sql);

            int count = 1;
            while (resultSet.next()) {
                log.info("第{}次",count);
                Map hashMap = new HashMap();

                String years =resultSet.getString("yearv");
                hashMap.put("dateField_lzuyn2l8", UtilDateTime.parse(years,"yyyy"));
                hashMap.put("textField_m0g4itw4", years);
                hashMap.put("textField_m0g4itw6",resultSet.getString("SupplierCode"));
                hashMap.put("textField_m0g4itw5",resultSet.getString("SupplierName"));
                hashMap.put("numberField_m0g4itw7",resultSet.getBigDecimal("BeginMoney")); //期初金额
                hashMap.put("numberField_m0g4itw8",resultSet.getBigDecimal("InvoiceMoney")); //本年到票金额
                hashMap.put("numberField_m0g4itw9",resultSet.getBigDecimal("PayMoney"));//到票已付累计
                hashMap.put("numberField_m0g4itwb",resultSet.getBigDecimal("SumPayMoney")); //到票未付累计
                hashMap.put("numberField_m0g4itwa",resultSet.getBigDecimal("EstimationMoney")); //暂估金额

                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-09CDC75CDC6048379567EC87ED6CE7B6T8PP")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
                count++;
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                resultSet.close();
                statement.close();
                connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getProjectOperate() {
//        '"+year+"'
//        '"+month+"'
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        int daysInLastMonth = lastMonth.lengthOfMonth();
//        deleteMonthDate("FORM-5654B7C22E7546E9BBE7B4EF46DE08BAXZXU","textField_m0dkzhwo", String.valueOf(year),month);
        String yearAndMonth = year +"-"+month;


        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        Connection mysqlCon = null;
        PreparedStatement[] ps = {null};
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());
            mysqlCon = DriverManager.getConnection(mySqlBean.getUrl(), mySqlBean.getUsername(), mySqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            //获取生产成本-工资
            String sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '50010101', '500103', '500102', '500117' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);

            List<Map<String,Object>> personCostList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("person_cost_compute",resultSet.getString("JFFS"));
                personCostList.add(personCost);
            }
            log.info("personCostList:{}",personCostList.size());
            //获取生产成本-材料费
            sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '500114' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> materialList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("material_compute",resultSet.getString("JFFS"));
                materialList.add(personCost);
            }
            log.info("materialList:{}",materialList.size());

            //获取5001科目总生产成本
            sql = "SELECT\n" +
                    "\tA.yearv,\n" +
                    "\tA.monthv,\n" +
                    "\tA.xmcode,\n" +
                    "\tA.xmname,\n" +
                    "\tsum( A.JFFS ) JFFS,\n" +
                    "\tsum( A.DFFS ) DFFS \n" +
                    "FROM\n" +
                    "\t(\n" +
                    "\tSELECT\n" +
                    "\t\tgl_detail.yearv yearv,\n" +
                    "\t\tgl_detail.adjustperiod monthv,\n" +
                    "\t\torg_accountingbook.CODE orgcode,\n" +
                    "\t\torg_accountingbook.NAME orgname,\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) kmbm,\n" +
                    "\t\tbd_accasoa.dispname,\n" +
                    "\t\torg_dept.CODE bmcode,\n" +
                    "\t\torg_dept.NAME bmname,\n" +
                    "\t\tbd_project.project_code xmcode,\n" +
                    "\t\tbd_project.project_name xmname,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "\tFROM\n" +
                    "\t\tgl_detail gl_detail\n" +
                    "\t\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\t\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\t\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "\tWHERE\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) IN ('5001') \n" +
                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\t\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\t\tAND gl_detail.dr = 0 \n" +
                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\t\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\t\tAND 1 = 1 \n" +
                    "\tGROUP BY\n" +
                    "\t\tgl_detail.pk_accasoa,\n" +
                    "\t\tgl_detail.pk_accountingbook,\n" +
                    "\t\tgl_detail.yearv,\n" +
                    "\t\tgl_detail.adjustperiod,\n" +
                    "\t\torg_dept.CODE,\n" +
                    "\t\torg_dept.NAME,\n" +
                    "\t\torg_accountingbook.CODE,\n" +
                    "\t\torg_accountingbook.NAME,\n" +
                    "\t\tbd_accasoa.dispname,\n" +
                    "\t\tbd_account.CODE,\n" +
                    "\t\tbd_project.project_code,\n" +
                    "\t\tbd_project.project_name \n" +
                    "\t) A \n" +
                    "GROUP BY\n" +
                    "\tA.yearv,\n" +
                    "\tA.monthv,\n" +
                    "\tA.xmcode,\n" +
                    "\tA.xmname \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> otherList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("other_compute",resultSet.getString("JFFS"));
                otherList.add(personCost);
            }
            log.info("otherList:{}",otherList.size());

            //管理费用分子6601+6602+6603
            sql = "SELECT\n" +
                    "\tsum( A.JFFS ) JFFS,\n" +
                    "\tsum( A.DFFS ) DFFS \n" +
                    "FROM\n" +
                    "\t(\n" +
                    "\tSELECT\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "\tFROM\n" +
                    "\t\tgl_detail gl_detail\n" +
                    "\t\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\t\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\t\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "\tWHERE\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) IN ( '6602', '6601' ) \n" +
                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\t\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\t\tAND gl_detail.dr = 0 \n" +
                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\t\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\t\tUNION ALL\n" +
                    "\tSELECT\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "\tFROM\n" +
                    "\t\tgl_detail gl_detail\n" +
                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "\tWHERE\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) IN ( '6603' ) \n" +
                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\t\tAND gl_detail.adjustperiod = '10' \n" +
                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\t\tAND gl_detail.dr = 0 \n" +
                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND 1 = 1 \n" +
                    "\t)A";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> manageList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("manage_compute",resultSet.getString("JFFS"));
                manageList.add(personCost);
            }
            log.info("manageList:{}",manageList.size());

            //管理费用分母
            sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '600101','600109','600102','600106','600103') \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> manageProjectList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("manage_project_compute",resultSet.getString("JFFS"));
                manageProjectList.add(personCost);
            }
            log.info("manageProjectList:{}",manageProjectList.size());

            //企业所得税6801
            sql = "SELECT\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tsubstring( bd_account.CODE, 0, 5 ) IN ( '6801' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> businessIncomeList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("business_income_compute",resultSet.getString("JFFS"));
                businessIncomeList.add(personCost);
            }
            log.info("businessIncomeList:{}",businessIncomeList.size());
//            1709222400
            List<String> startList = new ArrayList<>();
            startList.add(null);
            startList.add(String.valueOf(UtilDateTime.parse(yearAndMonth+"-"+daysInLastMonth,"yyyy-MM-dd").getTime()));

            log.info("开始日期：{}",yearAndMonth+"-"+daysInLastMonth);
            List<String> endList = new ArrayList<>();
            endList.add(String.valueOf(UtilDateTime.parse(yearAndMonth+"-01","yyyy-MM-dd").getTime()));
            endList.add(null);
            log.info("结束日期：{}",yearAndMonth+"-01");

            List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                    .build());


            List<Map> projectList = new ArrayList<>();
            dataList.forEach(e-> {
                List<Map> tableList = ydService.queryDetails(YDParam.builder().
                        appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(e.get("formInstanceId").toString())
                        .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                        .tableFieldId("tableField_lrru2tnq")
                        .build());
                tableList = tableList.stream().filter(item -> yearAndMonth.equals(item.get("textField_luh0k82j"))).collect(Collectors.toList());
                if (!tableList.isEmpty()){
                    projectList.addAll(tableList);
                }
            });
            Double sumProject = projectList.size()==0?0.0:projectList.stream().filter(item -> !(""+item.get("numberField_lryopn7o_value")+item.get("numberField_lrru2to2_value")).isEmpty()).map(e -> e.get("numberField_lryopn7o_value") == null ? Double.parseDouble(e.get("numberField_lrru2to2_value").toString()) : Double.parseDouble(e.get("numberField_lryopn7o_value").toString())).reduce(0.0, Double::sum);

            List<Map> personList = ydService.queryFormData_all(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formUuid("FORM-B8997C89645241F996FB7A53AAC393B08R96")
                    .searchFieldJson(JSON.toJSONString(UtilMap.map("radioField_m1zuxqf0","是")))
                    .build());
            List<Map> smallList = ydService.queryFormData_all(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formUuid("FORM-7E47DA25341647ED9B17F3BC728AC3F7XRSZ")
                    .searchFieldJson(JSON.toJSONString(UtilMap.map("dateField_lr3cqz3x, dateField_lr3cqz3y", startList,endList)))
                    .build());
            Double sumSamll = smallList.size()==0?0.0:smallList.stream().map(e -> new Double(e.get("numberField_lrnc4oxe_value").toString())).reduce(0.0, Double::sum);
            String insert = "INSERT INTO `dingtalk`.`lanyun_project_analysis_copy1`(`project_name`, `belong_project`, `month`, `status`, `predict_income`, `open`, `income`, `person`, `person_cost`, `material`, `other_cost`, `cost_sum`, `taxes`, `gross_profit`, `gross_margin`, `overhead`, `corporate_income_tax`, `net_profit`, `net_margin`, `format`, `customer_system`, `profit_loss`, `approach_date`, `level`, `notes`, `monthString`) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?) ";
            ps[0] = mysqlCon.prepareStatement(insert);

            dataList.forEach(e->{
                List<Map> tableList = ydService.queryDetails(YDParam.builder().
                        appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(e.get("formInstanceId").toString())
                        .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                        .tableFieldId("tableField_lrru2tnq")
                        .build());
                tableList = tableList.stream().filter(item -> yearAndMonth.equals(item.get("textField_luh0k82j"))).collect(Collectors.toList());
                String code = e.get("textField_ltxrn8h1").toString();
                String name = e.get("textField_lrr3rg6i").toString();
                final Double[] sum = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
                final Integer[] person = {0};
                if (!tableList.isEmpty()){
                    tableList.forEach(t->{
                        double open = "".equals(t.get("numberField_lrru2to2_value")) ? 0.0: Double.parseDouble(t.get("numberField_lrru2to2_value").toString());
                        double income = "".equals(t.get("numberField_lryopn7o_value")) ? open : Double.parseDouble(t.get("numberField_lryopn7o_value").toString());
                        sum[7] = sum[7] + income;
                        sum[8] = sum[8] +open;
                    });
                }

                //小业主合同月金额数据
                if (ObjectUtil.isNotNull(smallList)){
                    smallList.forEach(s->{
                        if (code.equals(s.get("textField_lrnc4owh"))){
                            double monthAmount = "".equals(s.get("numberField_lrnc4oxe_value")) ? 0.0 : Double.parseDouble(s.get("numberField_lrnc4oxe_value").toString());
                            sum[0] = sum[0] + monthAmount;
                        }
                    });
                }
                //算薪人数
                if (ObjectUtil.isNotNull(personList)){
                    personList.forEach(s->{
                        if (name.equals(s.get("textField_lxmxtgkp"))){
                            person[0] = person[0] + 1;
                        }
                    });
                }
                //生产成本-工资
                if (ObjectUtil.isNotNull(personCostList)){
                    personCostList.forEach(s->{
                        if (code.equals(s.get("xmcode"))){
                            double person_cost_compute = s.get("person_cost_compute") == null ? 0.0 : Double.parseDouble(s.get("person_cost_compute").toString());
                            sum[1] = sum[1] + person_cost_compute;
                        }
                    });
                }
                //500114生产成本-材料费
                if (ObjectUtil.isNotNull(materialList)){
                    materialList.forEach(s->{
                        if (code.equals(s.get("xmcode"))){
                            double material_compute = s.get("material_compute") == null ? 0.0 : Double.parseDouble(s.get("material_compute").toString());
                            sum[2] = sum[2] + material_compute;
                        }
                    });
                }
                //5001生产成本-其他
                if (ObjectUtil.isNotNull(otherList)) {
                    otherList.forEach(s -> {
                        if (code.equals(s.get("xmcode"))) {
                            double other_compute = s.get("other_compute") == null ? 0.0 : Double.parseDouble(s.get("other_compute").toString());
                            sum[3] = sum[3] + other_compute;
                        }
                    });
                }
                //6001+6002+6003 管理费用分子
                if (ObjectUtil.isNotNull(manageList)){
                    manageList.forEach(s->{
                        double manage_compute = s.get("manage_compute") == null ? 0.0 : Double.parseDouble(s.get("manage_compute").toString());
                        sum[4] = sum[4] + manage_compute;
                    });
                }
                //600101+600102+600103+600106+600109 管理费用分母
                if (ObjectUtil.isNotNull(manageProjectList)){
                    manageProjectList.forEach(s->{
                        if (code.equals(s.get("xmcode"))) {
                            double manage_project_compute = s.get("manage_project_compute") == null ? 0.0 : Double.parseDouble(s.get("manage_project_compute").toString());
                            sum[5] = sum[5] + manage_project_compute;
                        }
                    });
                }
                //6801企业所得税
                if(ObjectUtil.isNotNull(businessIncomeList)){
                    businessIncomeList.forEach(s->{
                        if (code.equals(s.get("xmcode"))) {
                            double business_income_compute = s.get("business_income_compute") == null ? 0.0 : Double.parseDouble(s.get("business_income_compute").toString());
                            sum[6] = sum[6] + business_income_compute;
                        }
                    });
                }

                try {
                    ps[0].setObject(1,name);
                    ps[0].setObject(2,null);
                    ps[0].setObject(3,UtilDateTime.parse(yearAndMonth,"yyyy-MM").getTime());
                    ps[0].setObject(4,e.get("selectField_lrn2oy4a")==null?null:e.get("selectField_lrn2oy4a").toString());
                    ps[0].setObject(5,sum[7]/1.06/10000);
                    ps[0].setObject(6,sum[8]/1.06/10000);
                    ps[0].setObject(7,sum[0]/1.06/10000);
                    ps[0].setObject(8,person[0]);
                    ps[0].setObject(9,sum[1]/10000);
                    ps[0].setObject(10,sum[2]/10000);
                    ps[0].setObject(11,(sum[3]-sum[2]-sum[1])/10000);
                    ps[0].setObject(12,sum[3]/10000);
                    ps[0].setObject(13,0);
                    ps[0].setObject(14,(sum[7]+sum[8]-sum[3])/10000);
                    ps[0].setObject(15,(sum[7]+sum[8]) == 0.0 ? 0.0:(sum[7]+sum[8]-sum[3])/(sum[7]+sum[8]));
                    double glfy = 0.0;
                    if (sum[5]!=0.0){
                        glfy = sum[4]/sum[5]*(sum[7]+sum[8])/10000;
                    }
                    ps[0].setObject(16,glfy);
                    double corporate_income_tax = 0.0;
                    if ((sumProject+sumSamll) != 0.0){
                        corporate_income_tax = (sum[7]+sum[8])/(sumProject+sumSamll)*sum[6];
                    }
                    //企业所得税corporate_income_tax
                    ps[0].setObject(17,corporate_income_tax);
                    ps[0].setObject(18,((sum[7]+sum[8]-sum[3]) - glfy - corporate_income_tax)/10000);
                    double net_margin = (sum[7] + sum[8]) == 0.0 ? 0.0:((sum[7] + sum[8] - sum[3]) - glfy - corporate_income_tax) / (sum[7] + sum[8]);
                    ps[0].setObject(19,net_margin);
                    String profit_loss = "";
                    if (net_margin < 0){
                        profit_loss = "亏损";
                    }else if (net_margin >=0 && net_margin <=0.05){
                        profit_loss = "净利较低";
                    }else if(net_margin > 0.05){
                        profit_loss = "盈利";
                    }
                    ps[0].setObject(20,e.get("selectField_lrhjdu45")==null?null:e.get("selectField_lrhjdu45").toString());
                    ps[0].setObject(21,e.get("textField_lrn2oy4n")==null?null:e.get("textField_lrn2oy4n").toString());
                    ps[0].setObject(22,profit_loss);
                    ps[0].setObject(23,e.get("dateField_lrn2oy54")==null?null:e.get("dateField_lrn2oy54").toString());
                    ps[0].setObject(24,e.get("selectField_ltfgfke7")==null?null:e.get("selectField_ltfgfke7").toString());
                    ps[0].setObject(25,"");
                    ps[0].setObject(26,yearAndMonth);

                    ps[0].addBatch();
                } catch (SQLException ex) {
                    ex.printStackTrace();
                }
            });
            ps[0].executeBatch();
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (mysqlCon != null) mysqlCon.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();

            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private void deleteMonthDate(String formUuid,String key, String year, String month){
        String yearAndMonth = year;
        if (ObjectUtil.isNotNull(month)){
            yearAndMonth = yearAndMonth + "-" + month;
        }
        List<Map> allProjectList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid(formUuid)
                .searchFieldJson(JSON.toJSONString(UtilMap.map(key, yearAndMonth)))
                .build());
        allProjectList.forEach(e->{
            ydClient.operateData(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formInstanceId(e.get("formInstanceId").toString())
                    .build(), YDConf.FORM_OPERATION.delete);
        });
    }
}
