package com.malk.lanyun.service.impl;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.malk.lanyun.Mapper.ProjectAnalysisMapper;
import com.malk.lanyun.entity.ProjectAnalysis;
import com.malk.lanyun.service.TimerService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.service.aliwork.YDClient;
import com.malk.service.aliwork.YDService;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Personnel;
import com.malk.utils.UtilDateTime;
import com.malk.utils.UtilExcel;
import com.malk.utils.UtilMap;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.text.DecimalFormat;
import java.time.LocalDateTime;
import java.util.*;
import java.util.stream.Collectors;

import static java.lang.Integer.parseInt;


@Service
@Slf4j
public class TimerServiceImpl implements TimerService {
    @Value("${spring.datasource.url}")
    private String url;
    @Value("${spring.datasource.username}")
    private String username;
    @Value("${spring.datasource.password}")
    private String password;
    @Value("${spring.datasource.driver-class-name}")
    private String driver;
    @Value("${dingtalk.appKey}")
    private String dingtalkAppKey;
    @Value("${dingtalk.appSecret}")
    private String dingtalkAppSecret;
    @Value("${dingtalk.agentId}")
    private Long agentId;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private YDService ydService;

    @Autowired
    private YDClient ydClient;

    @Autowired
    private DDClient ddClient;

    @Autowired
    private DDClient_Personnel ddClientPersonnel;

    /**
     * 月度定额更新
     */
    @Override
    public String updateYuedudinge() {
        //获取上月时间戳
        long lastMonth = DateUtil.beginOfMonth(DateUtil.lastMonth()).getTime();
        List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
//                .searchFieldJson(JSON.toJSONString(UtilMap.map("textField_lrr3rg6h", "XM00345")))
                .build());
        log.info("项目点数据, {}", dataList.size());
        dataList.forEach(formData -> {
            //获取撤场时间
            Long withdrawalTime = formData.get("dateField_lzaqu26p")==null?null:DateUtil.beginOfMonth(DateUtil.date(Long.parseLong(formData.get("dateField_lzaqu26p").toString()))).getTime();
            if (UtilMap.getString(formData, "selectField_lrn2oy4a").equals("进行中") || (ObjectUtil.isNotNull(withdrawalTime) && lastMonth == withdrawalTime)){
                List<Map> details = UtilMap.getList(formData, "tableField_lrru2tnq");
//            details = details.stream().filter(item -> UtilMap.isNotBlankString(item, "dateField_lrru2tnr")).collect(Collectors.toList());
                // 数据格式化
//            details.forEach(row -> {
//                row.put("textField_luh0k82j", UtilDateTime.format(new Date(UtilMap.getLong(row, "dateField_lrru2tnr")), "yyyy-MM"));
//            }
//            });
//            Collections.sort(details, Comparator.comparingLong(o -> UtilMap.getLong(o, "dateField_lrru2tnr")));

                // 查找当月数据
                LocalDateTime currentDate = UtilDateTime.firstDayOfLastMonth(LocalDateTime.now());
//            LocalDateTime currentDate = UtilDateTime.parseLocalDateTime("2024-07-01 00:00:00");

                try {
                    Optional optional = details.stream().filter(item -> UtilDateTime.getLocalDateTimeTimeStamp(currentDate) == UtilMap.getLong(item, "dateField_lrru2tnr")).findAny();
                    log.info("上个月数据, {}, {}", currentDate, optional);
                    if (!optional.isPresent() || UtilMap.getFloat((Map) optional.get(), "numberField_lrru2tnz") != 0f) {
                        return;
                    }

                    LocalDateTime lastMonthDate = UtilDateTime.firstDayOfLastMonth(currentDate);
//            LocalDateTime lastMonthDate = UtilDateTime.parseLocalDateTime("2024-06-01 00:00:00");
                    Map currentRow = (Map) optional.get();
                    optional = details.stream().filter(item -> UtilDateTime.getLocalDateTimeTimeStamp(lastMonthDate) == UtilMap.getLong(item, "dateField_lrru2tnr")).findAny();
                    log.info("上上月数据, {}, {}", lastMonthDate, optional);

                    float price;
                    if (!optional.isPresent() || UtilMap.getFloat((Map) optional.get(), "numberField_lrru2tnz") == 0f) {
                        price = UtilMap.getFloat(currentRow, "numberField_lrru2tns");
                        currentRow.put("numberField_lrru2tnz", price); // 取本月收入定额
                    } else {
                        price = UtilMap.getFloat((Map) optional.get(), "numberField_lrru2tnz");
                        currentRow.put("numberField_lrru2tnz", price); // 取上月收入预估
                    }
                    //明细合计
                    currentRow.put("numberField_lryopn7o", UtilMap.getFloat(currentRow, "numberField_lrru2tnz") + UtilMap.getFloat(currentRow, "numberField_lrru2to0") + UtilMap.getFloat(currentRow, "numberField_lrru2to1"));
                    currentRow.put("numberField_m1hhyqiv", UtilMap.getFloat(currentRow, "numberField_lrru2tnz") + UtilMap.getFloat(currentRow, "numberField_lrru2to0") + UtilMap.getFloat(currentRow, "numberField_lrru2to1"));

                    price += UtilMap.getFloat(formData, "numberField_lutjev0u");
                    log.info("price, {}", price);

                    System.out.println("更新内容：" + JSON.toJSONString(UtilMap.map("tableField_lrru2tnq, numberField_lutjev0u", details, price)));
                    // 合计初始化
//            price = details.stream().map(item -> UtilMap.getFloat(item, "numberField_lrru2tnz")).collect(Collectors.toList()).stream().reduce(0f, (acc, cur) -> acc + cur);
                    ydClient.operateData(YDParam.builder()
                            .appType("APP_ERBDTFS82HOVBPL3NFH0")
                            .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                            .formInstanceId(UtilMap.getString(formData, "formInstanceId"))
//                    .useLatestVersion(true)
                            .updateFormDataJson(JSON.toJSONString(UtilMap.map("tableField_lrru2tnq, numberField_lutjev0u", details, price)))
                            .build(), YDConf.FORM_OPERATION.update);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });

        return null;
    }

    @Override
    public void updateBigOut() {
        //获取上月月份的时间戳
        Date beginDate = DateUtil.beginOfMonth(DateUtil.lastMonth());
        String lastMonth = DateUtil.format(beginDate,"yyyy-MM");
        long beginDateTime = beginDate.getTime();
        String strLastMonth = String.valueOf(beginDateTime);
        //获取本月时间戳
        long todayTime = DateUtil.beginOfMonth(new Date()).getTime();
        String year = DateUtil.format(DateUtil.beginOfYear(new Date()),"yyyy-MM");
        Date endDate = DateUtil.endOfMonth(DateUtil.lastMonth());
        List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("selectField_lr25icd0", "大业主")))
                .build());
        log.info("项目点数据, {}", dataList.size());
        List<Map> list = new  ArrayList<>();
        dataList.forEach(e -> {
            if (ObjectUtil.isNotNull(e.get("tableField_lrru2tnq"))){
                list.addAll((Collection<? extends Map>) e.get("tableField_lrru2tnq"));
            }
        });
//        double income = list.stream().filter(e -> ("2024-08").equals(e.get("textField_luh0k82j").toString())).mapToDouble(e -> e.get("numberField_lryopn7o_value").toString().equals("")?0.0: Double.parseDouble(e.get("numberField_lryopn7o").toString())).sum();
//        double open = list.stream().filter(e -> ("2024-08").equals(e.get("textField_luh0k82j").toString())).mapToDouble(e -> e.get("numberField_lrru2to2_value").toString().equals("")?0.0: Double.parseDouble(e.get("numberField_lryopn7o").toString())).sum();
        double income = list.stream().filter(e -> lastMonth.compareTo(e.get("textField_luh0k82j").toString())>=0 && year.compareTo(e.get("textField_luh0k82j").toString())<=0)
                .mapToDouble(e -> e.get("numberField_lryopn7o_value").toString().equals("")?0.0: Double.parseDouble(e.get("numberField_lryopn7o_value").toString())).sum();
        double open = list.stream().filter(e -> lastMonth.compareTo(e.get("textField_luh0k82j").toString())>=0 && year.compareTo(e.get("textField_luh0k82j").toString())<=0)
                .mapToDouble(e -> e.get("numberField_lrru2to2_value").toString().equals("")?0.0: Double.parseDouble(e.get("numberField_lrru2to2_value").toString())).sum();
        ydClient.operateData(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-9FC782C5FDD0449B8B711FB29F3E29567YSL")
                .formDataJson(JSON.toJSONString(UtilMap.map("selectField_lxoelnwa, dateField_lxcutodb, numberField_lxcutodd, numberField_lxcutodf","大业主",todayTime,income,open)))
                .build(), YDConf.FORM_OPERATION.create);


        dataList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-7E47DA25341647ED9B17F3BC728AC3F7XRSZ")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("selectField_lrnd0lxr", "小业主")))
                .build());
        log.info("小业主档案数据, {}", dataList.size());
        list.clear();
        dataList.forEach(e -> {
            if (ObjectUtil.isNotNull(e.get("tableField_lr3dmdpk"))){
                System.out.println("项目点编号:{}"+e.get("instanceId").toString());
                list.addAll((Collection<? extends Map>) e.get("tableField_lr3dmdpk"));
                System.out.println("testlist:{}"+e.get("tableField_lr3dmdpk").toString());
            }
        });
//        open = list.stream().filter(e -> strLastMonth.compareTo( e.get("dateField_lus8aj42").toString())>=0 && year.compareTo(e.get("dateField_lus8aj42").toString())<=0)
//                .mapToDouble(e -> e.get("numberField_lr3dmdpn_value").toString().equals("")?0.0: Double.parseDouble(e.get("numberField_lr3dmdpn_value").toString())).sum();
        open = list.stream().filter(e -> lastMonth.compareTo(e.get("textField_lr3dmdpl").toString())>=0 && year.compareTo(e.get("textField_lr3dmdpl").toString())<=0)
                .mapToDouble(e -> e.get("numberField_lr3dmdpn_value").toString().equals("")?0.0: Double.parseDouble(e.get("numberField_lr3dmdpn_value").toString())).sum();
        ydClient.operateData(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-9FC782C5FDD0449B8B711FB29F3E29567YSL")
                .formDataJson(JSON.toJSONString(UtilMap.map("selectField_lxoelnwa, dateField_lxcutodb, numberField_lxcutodf","小业主",todayTime,open)))
                .build(), YDConf.FORM_OPERATION.create);
    }

    @Override
    public void fresh() {
        List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-7E47DA25341647ED9B17F3BC728AC3F7XRSZ")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("selectField_lrnd0lxr", "小业主")))
                .build());
        log.info("小业主档案_测试, {}", dataList.size());
        dataList.forEach(e -> {
            log.info("e1:{}",e.toString());
            List<Map> list = (List<Map>) e.get("tableField_lr3dmdpk");
            if (ObjectUtil.isNotNull(e.get("tableField_lr3dmdpk"))){
                list.forEach(v->{
                    if (v.size()>3){
                        String dateStr =  DateUtil.format(DateUtil.date(Long.parseLong(v.get("dateField_lus8aj42").toString())),"yyyy-MM");
                        log.info("date:{}",dateStr);
                        v.put("textField_lr3dmdpl",dateStr);
                    }
                });
            }
            e.put("tableField_lr3dmdpk",list);
            log.info("e2:{}",e.toString());
            ydClient.operateData(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formInstanceId(UtilMap.getString(e, "formInstanceId"))
                    .useLatestVersion(true)
                    .updateFormDataJson(JSONObject.toJSONString(new HashMap<>()))
//                    .updateFormDataJson(JSON.toJSONString(UtilMap.map("tableField_lr3dmdpk", list)))
                    .build(), YDConf.FORM_OPERATION.update);
        });
    }

    @Override
    public void execlExport(Map data,HttpServletResponse response, HttpServletRequest request) {
        if (data.isEmpty()){
            return;
        }
        String formInstId = data.get("formInstId").toString();
        log.info("已获取流程实例ID为：{}",data.get("formInstId").toString());
        // 动态表头模板导出
        Map formData = ydClient.queryData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(formInstId)
                        .build(),
                YDConf.FORM_QUERY.retrieve_id).getFormData();
        log.info("formData:{}",formData);
        //获取主表字段
        final String[] keys = {""};
        final String[] valuses = {""};
        formData.forEach((k,v)->{
            if (!k.toString().equals("pageSection_lr3gzi9i") && !k.toString().equals("pageSection_ltxyt76g")){
                keys[0] = keys[0] + k + ", ";
                valuses[0] = valuses[0] + v.toString() + ", ";
            }
        });
        Map<String, String> dataMain = UtilMap.map(keys[0], valuses[0]);
        log.info("dataMain:{}",dataMain);
        //获取订单日期
        long dateFiled = Long.parseLong(formData.get("dateField_lr26l3h2").toString());
        if (ObjectUtil.isNotEmpty(dateFiled)){
            String dateStr = DateUtil.date(dateFiled).toString("yyyy-MM-dd");
            dataMain.put("dateField_lr26l3h2",dateStr);
        }
        //获取供应商名称
        String association = formData.get("associationFormField_lr26l3he_id").toString();
        log.info(association);
        if (ObjectUtil.isNotEmpty(association)){
            association = JSON.parse(association).toString();
            JSONArray jsonArray = JSON.parseArray(association);
            JSONObject jsonObject = (JSONObject) jsonArray.get(0);
            String title = jsonObject.get("title").toString();
            dataMain.put("title",title);
        }
        //获取文件标题
        String fileName = dataMain.get("textField_lr26y1io") + dataMain.get("textField_lz2fk0wc") + "采购订单";

        List<Map> dataList = ydService.queryDetails(YDParam.builder().
                appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formInstanceId(formInstId)
                .formUuid("FORM-61F329A9DFFE4CF0BBEC0FDC34C42C03QJKQ")
                //测试
//                .formUuid("FORM-44AF067BF733464F8431620612726615RNNV")
                .tableFieldId("tableField_ltxyt76f")
                .build());
        log.info("dataList1:{}",dataList);
        for (int i = 0; i < dataList.size(); i++) {
            dataList.get(i).put("row",i+1);
            String person = dataList.get(i).get("textField_lu2gzzab").toString();
            String phone = dataList.get(i).get("textField_lu2gzzac").toString();
            final String[] address = {""};
            if (ObjectUtil.isNotNull(dataList.get(i).get("addressField_m1mxnnno"))){
                Object parse = JSON.parse(dataList.get(i).get("addressField_m1mxnnno").toString());
                JSONObject jsonObject = (JSONObject) parse;
                JSONArray jsonArray = JSON.parseArray(jsonObject.get("regionText").toString());
                jsonArray.forEach(e->{
                    JSONObject object = (JSONObject) e;
                    String zhCn = object.get("zh_CN").toString();
                    address[0]  =  address[0] + zhCn + "/";
                });
                String substring = address[0].substring(0, address[0].length() - 1);
                dataList.get(i).put("addressField_m1mxnnno",substring);
            }
            String information = person + " " + phone;
            dataList.get(i).put("information",information);
        }
        log.info("dataList:{}",dataList);
        String text = "一、订单说明：\n" +
                "1.供应商需按订单内容，向采购方按时、按量提供质量合格的商品（如一张订单分多次送货的，将以末次送货时间作为该订单的送货时间）。\n" +
                "2.供应商配送物品与订单不符，采购方接收人有权拒收、要求换货或给与相应的赔偿。\n" +
                "3.供应商未按订单约定时间配送物品，需按照订单总价的5%作为单日违约金，按照延迟天数向采购方支付。\n" +
                "4.供应商送货时，需向采购方接收人提供供应商送货签收单据的客户联，采购方将作为付款的书面依据留存。\n" +
                "5.供应商完成物品配送后，5个工作日内需向采购方提交与订单内容相符的增值税专用发票。\n" +
                "6.采购方在收到供应商提供的与订单相符的物品及相应发票和单据后，将按照双方约定的付款周期支付货款。\n" +
                "7.采购方以传真和邮件方式，向供应商提供《采购订单》；供应商接收《采购订单》后，需以传真或邮件方式进行签收。\n" +
                "8.采购方以供应商传真或邮件签收，作为该《采购订单》正式履行的依据。\n" +
                "9.采购订单作为供需双方的日常业务办理依据，双方合作的相关法律依据以双方签订的合作协议为准。\n" +
                "10.严禁除采购以外的任何人员直接向供应商订购物资，如供应商在未收到采购订单的情况下进行物资配送，采购一律不予结算该账款。\n" +
                "严禁供应商向除采购方以外的任何第三方泄露采购单价，造成采购方名誉、信誉、财产的一切损失将由供应商承担。\n" +
                "二、备注：采购订单敲章后与发票一起寄回，以便后期确认。\n" +
                "发票寄送地址：上海市宝山区双城路803弄宝莲城9号楼27层\n" +
                "联系人：浦水菊  联系电话：60671366  转 828";
        dataMain.put("text",text);
        int numSum = dataList.stream().mapToInt(e -> e.get("numberField_ltxyt75z").toString().equals("") ? 0 : parseInt(e.get("numberField_ltxyt75z").toString())).sum();
        Double sumTotal = dataList.stream().mapToDouble(e -> e.get("numberField_ltxyt764").toString().equals("") ? 0 : Double.parseDouble(e.get("numberField_ltxyt764").toString())).sum();
        dataMain.put("num_sum",String.valueOf(numSum));
        dataMain.put("sum_total",String.valueOf(sumTotal));

        UtilExcel.exportMapAndListByTemplate(response, dataMain, dataList, Map.class, fileName, "Template.xlsx");
    }

    @Override
    public void monthRiskMerits() {
        // 获取月初日期
        long beginTime = DateUtil.beginOfMonth(DateUtil.lastMonth()).getTime();
        long sendTime = DateUtil.beginOfMonth(new Date()).getTime();
        List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-0536AD7797894C94BCAC4BAC0BBBE86BUQE1")
//                .searchFieldJson(JSON.toJSONString(UtilMap.map("selectField_lrnd0lxr", "小业主")))
                .build());
        dataList.forEach(e->{
            log.info(e.toString());
            String department = e.get("departmentSelectField_ls2tx0tf_id").toString();
            log.info("部门：{}",department);
            String header = e.get("employeeField_ls2tx0tg_id").toString();
            log.info("负责人：{}",header);
            List<Map> tableList = (List<Map>) e.get("tableField_ls2tx0tl");
            if (tableList.size()>0) {
                tableList.forEach(f->{
                    f.forEach((k,v)->{
                        if (k.toString().equals("textField_ls2tx0tn")){
                            f.put("textField_ls2u8mc7",v);
                            f.remove(k);
                        }
                    });
                });
            }
            /*关联表单控件*/
            JSONArray jsonArray = new JSONArray();
            Map<String, Object> jsonMap = UtilMap.map("appType, formUuid, formType, instanceId, title",
                    "APP_ERBDTFS82HOVBPL3NFH0","FORM-0536AD7797894C94BCAC4BAC0BBBE86BUQE1","receipt",e.get("instanceId"),e.get("textField_ls2upvtq"));
            JSONObject jsonObject = new JSONObject(jsonMap);
            jsonArray.add(jsonObject);
            /*发起流程*/
            ydClient.operateData(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formUuid("FORM-A4B37CFEB8524947939C00523373532BT3TH")
                    .formDataJson(JSON.toJSONString(UtilMap.map("dateField_ls2u8mbv, departmentSelectField_ls2u8mbw, employeeField_ls2u8mbx, tableField_ls2u8mc6, associationFormField_ls2u8mcb, dateField_ls1ky8c5, employeeField_ls1ky8c3",
                            beginTime,department,header,tableList,jsonArray,sendTime,YDConf.PUB_ACCOUNT)))
                    .build(), YDConf.FORM_OPERATION.start);
        });
    }

    @SneakyThrows
    @Override
    public  Map<String, Object> projectAnalysisGroup(Map<String, Object> data){
        final String[] sql = {"","","","","",""};
        /*分页*/
        int pageStart = (parseInt(data.get("page").toString()) - 1) * (parseInt(data.get("num").toString())-1);
        int pageSize = parseInt(data.get("num").toString()) - 1;
        log.info("pageStart:{}",pageStart);
        log.info("pageEnd:{}",pageSize);
        data.remove("page");
        data.remove("num");
        if (!data.containsKey("month")){
            /*sql获取第一层按月求和数据*/
            sql[0] = "SELECT " +
                    " `month`, " +
                    " sum( predict_income ) predict_income," +
                    " NULL as project_name, " +
                    " SUM( `open` ) `open`, " +
                    " SUM( income ) income, " +
                    " SUM( person ) person, " +
                    " SUM( person_cost ) person_cost, " +
                    " SUM( material ) material, " +
                    " SUM( other_cost ) other_cost, " +
                    " SUM( cost_sum ) cost_sum, " +
                    " SUM( taxes ) taxes, " +
                    " SUM( gross_profit ) gross_profit, " +
                    " CONCAT(ROUND(SUM( gross_profit )/ SUM( income )*100,2),'%') gross_margin, " +
                    " SUM( overhead ) overhead, " +
                    " SUM( corporate_income_tax ) corporate_income_tax, " +
                    " SUM( net_profit ) net_profit, " +
                    " CONCAT(ROUND(SUM( net_profit )/ SUM( income )*100,2),'%') net_margin  " +
                    "FROM " +
                    " lanyun_project_analysis  " +
                    " WHERE 1=1 " ;
            /*sql获取第一层合计数据*/
            sql[1]= "SELECT " +
                    " '总合计' as `month` , " +
                    " sum( predict_income ) predict_income," +
                    " NULL as project_name, " +
                    " SUM( `open` ) `open`, " +
                    " SUM( income ) income, " +
                    " SUM( person ) person, " +
                    " SUM( person_cost ) person_cost, " +
                    " SUM( material ) material, " +
                    " SUM( other_cost ) other_cost, " +
                    " SUM( cost_sum ) cost_sum, " +
                    " SUM( taxes ) taxes, " +
                    " SUM( gross_profit ) gross_profit, " +
                    " CONCAT(ROUND(SUM( gross_profit )/ SUM( income )*100,2),'%') gross_margin, " +
                    " SUM( overhead ) overhead, " +
                    " SUM( corporate_income_tax ) corporate_income_tax, " +
                    " SUM( net_profit ) net_profit, " +
                    " CONCAT(ROUND(SUM( net_profit )/ SUM( income )*100,2),'%') net_margin  " +
                    "FROM " +
                    " lanyun_project_analysis  " +
                    "WHERE 1=1 " ;
            /*sql获取第一层数据总数*/
            sql[2] = "SELECT " +
                    " COUNT(*) total_count  " +
                    "FROM " +
                    " ( SELECT `month` FROM lanyun_project_analysis WHERE 1 = 1 " ;
            if (ObjectUtil.isNotNull(data.get("startDate"))) {
                sql[0] = sql[0] + " AND `month` >= \"" + data.get("startDate") +"\" " ;
                sql[1] = sql[1] + " AND `month` >= \"" + data.get("startDate") +"\" " ;
                sql[2] = sql[2] + " AND `month` >= \"" + data.get("startDate") +"\" " ;
            } else if (ObjectUtil.isNotNull(data.get("endDate"))) {
                sql[0] = sql[0] + " AND `month` <= \"" + data.get("endDate") +"\" " ;
                sql[1] = sql[1] + " AND `month` <= \"" + data.get("endDate") +"\" " ;
                sql[2] = sql[2] + " AND `month` <= \"" + data.get("endDate") +"\" " ;
            }
            sql[0] = sql[0] +
                    " GROUP BY " +
                    " `month`" +
                    " order by `month` DESC LIMIT " + pageStart + "," + pageSize;
            sql[2] = sql[2] +
                    "  GROUP BY `month` ) t1 ";
            log.info("sql[0]:{}",sql[0]);
            log.info("sql[1]:{}",sql[1]);
        }else {
            /*sql获取第二层月明细数据*/
            sql[0] = "SELECT " +
                    " `month`," +
                    "  project_name, " +
                    "  predict_income, " +
                    "  `open`, " +
                    "  income, " +
                    "  person, " +
                    "  person_cost, " +
                    "  material, " +
                    "  other_cost, " +
                    "  cost_sum, " +
                    "  taxes, " +
                    "  gross_profit, " +
                    "  CONCAT(ROUND(gross_margin*100,2),'%') gross_margin, " +
                    "  overhead, " +
                    "  corporate_income_tax, " +
                    "  net_profit, " +
                    "  CONCAT(ROUND(net_margin*100,2),'%') net_margin  " +
                    "FROM " +
                    " lanyun_project_analysis " +
                    " WHERE 1=1";
            /*sql获取第二层合计数据*/
            sql[1] = "SELECT " +
                    " '总合计' as `month`, " +
                    " sum( predict_income ) predict_income," +
                    " NULL as project_name, " +
                    " SUM( `open` ) `open`, " +
                    " SUM( income ) income, " +
                    " SUM( person ) person, " +
                    " SUM( person_cost ) person_cost, " +
                    " SUM( material ) material, " +
                    " SUM( other_cost ) other_cost, " +
                    " SUM( cost_sum ) cost_sum, " +
                    " SUM( taxes ) taxes, " +
                    " SUM( gross_profit ) gross_profit, " +
                    " CONCAT(ROUND(SUM( gross_profit )/ SUM( income )*100,2),'%') gross_margin, " +
                    " SUM( overhead ) overhead, " +
                    " SUM( corporate_income_tax ) corporate_income_tax, " +
                    " SUM( net_profit ) net_profit, " +
                    " CONCAT(ROUND(SUM( net_profit )/ SUM( income )*100,2),'%') net_margin " +
                    " FROM " +
                    " lanyun_project_analysis  " +
                    " WHERE 1=1 ";
            /*sql获取第二层数据总数*/
            sql[2] = "SELECT " +
                    " COUNT(*) total_count " +
                    " FROM " +
                    " lanyun_project_analysis  " +
                    " WHERE 1=1 ";
            if (data.containsKey("startDate") || data.containsKey("endDate")){
                data.remove("month");
            }
            data.forEach((k,v)->{
                if (k.equals("low") && ObjectUtil.isNotNull(v)){
                    sql[0] = sql[0] + " AND `net_margin` < 0.05" ;
                    sql[1] = sql[1] + " AND `net_margin` < 0.05" ;
                    sql[2] = sql[2] + " AND `net_margin` < 0.05" ;
                } else if (ObjectUtil.isNotNull(v) && k.equals("startDate")) {
                    sql[0] = sql[0] + " AND `month` >= \"" + v +"\"" ;
                    sql[1] = sql[1] + " AND `month` >= \"" + v +"\"" ;
                    sql[2] = sql[2] + " AND `month` >= \"" + v +"\"" ;
                } else if (ObjectUtil.isNotNull(v) && k.equals("endDate")) {
                    sql[0] = sql[0] + " AND `month` <= \"" + v +"\"" ;
                    sql[1] = sql[1] + " AND `month` <= \"" + v +"\"" ;
                    sql[2] = sql[2] + " AND `month` <= \"" + v +"\"" ;
                } else if (ObjectUtil.isNotNull(v) && !k.equals("low")){
                    sql[0] = sql[0] + " AND `" + k +"` = \"" + v +"\"" ;
                    sql[1] = sql[1] + " AND `" + k +"` = \"" + v +"\"" ;
                    sql[2] = sql[2] + " AND `" + k +"` = \"" + v +"\"" ;
                }
            });
            sql[0] = sql[0] +  "  order by `month` DESC LIMIT " + pageStart + "," + pageSize;
            log.info("sql[0]:{}",sql[0]);
            log.info("sql[2]:{}",sql[2]);
        }
        sql[3]="SELECT DISTINCT project_name FROM lanyun_project_analysis;";
        sql[4]="SELECT DISTINCT format FROM lanyun_project_analysis;";
        sql[5]="SELECT DISTINCT customer_system FROM lanyun_project_analysis;";

//        Class.forName(driver);
//        Connection connection = DriverManager.getConnection(url, username, password);
//        Statement statement = connection.createStatement();
        List<ProjectAnalysis> analysisList = jdbcTemplate.query(sql[0], new ProjectAnalysisMapper());
        List<ProjectAnalysis> analysisSum= jdbcTemplate.query(sql[1], new ProjectAnalysisMapper());
        List<Map<String, Object>> result = jdbcTemplate.queryForList(sql[2]);
        int totalCount = 0;
        if (result.size() >0) {
            totalCount = parseInt(result.get(0).get("total_count").toString());
        }
        List<Map<String, Object>> projects = jdbcTemplate.queryForList(sql[3]);
        projects.get(0).forEach((k,v)->{

        });
        List<Map<String, Object>> formats = jdbcTemplate.queryForList(sql[4]);
        List<Map<String, Object>> customers = jdbcTemplate.queryForList(sql[5]);
        analysisList.add(analysisSum.get(0));
        log.info("results:{}",analysisList);
        Map<String, Object> map = UtilMap.map("totalCount, data, projects, formats, customers", totalCount, analysisList,projects,formats,customers);
        if (ObjectUtil.isNotNull(analysisList)&&analysisList.size()>0){
            return map;
        }
        else {
            return null;
        }
    }

    @Override
    public void insertAnalysisList() {
        List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-954C78969A864D95A1BC0CE9F69299E8VI38")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("radioField_m0dkcxod", "否")))
                .build());

        if (ObjectUtil.isNotNull(dataList)&&dataList.size()>0){
            List<Map> monthList = new ArrayList<>();
            monthList = dataList.stream().collect(Collectors.collectingAndThen(Collectors.toCollection(() ->
                    new TreeSet<>(Comparator.comparing(o-> o.get("dateField_lcwv382").toString()))), ArrayList::new));
            Connection connection = null;
            PreparedStatement ps = null;
            try {
                Class.forName(driver);
                connection = DriverManager.getConnection(url, username, password);
                String deleteSql = "DELETE FROM `lanyun_project_analysis`WHERE CAST(`month` AS CHAR) = ?";
                ps = connection.prepareStatement(deleteSql);
                for (int i = 0; i < monthList.size(); i++) {
                    ps.setObject(1,monthList.get(i).get("dateField_lcwv382"));
                    ps.execute();
                }
                String sql = "INSERT INTO `lanyun_project_analysis`(`project_name`, `belong_project`, `month`, " +
                        "`status`, `predict_income`, `open`, `income`, `person`, `person_cost`, `material`, `other_cost`, " +
                        "`cost_sum`, `taxes`, `gross_profit`, `gross_margin`, `overhead`, `corporate_income_tax`, `net_profit`, " +
                        "`net_margin`, `format`, `customer_system`, `profit_loss`, `approach_date`, `level`, `notes`) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);";

                ps = connection.prepareStatement(sql);
                DecimalFormat df = new DecimalFormat("#.0000");
                for (int i = 0; i < dataList.size(); i++) {
                    ps.setObject(1,dataList.get(i).get("textField_dliiyul"));
                    ps.setObject(2,dataList.get(i).get("textField_bheotm5"));
                    ps.setObject(3,dataList.get(i).get("dateField_lcwv382"));
                    ps.setObject(4,dataList.get(i).get("textField_pa6o780"));
                    ps.setObject(5,dataList.get(i).get("numberField_5wyyb42"));
                    ps.setObject(6,dataList.get(i).get("numberField_c4acnrg"));
                    ps.setObject(7,dataList.get(i).get("numberField_zjdki9k"));
                    ps.setObject(8,dataList.get(i).get("numberField_hg6jznm"));
                    ps.setObject(9,dataList.get(i).get("numberField_7ga9c5w"));
                    ps.setObject(10,dataList.get(i).get("numberField_c3cqsfv"));
                    ps.setObject(11,dataList.get(i).get("numberField_avaexyf"));
                    ps.setObject(12,dataList.get(i).get("numberField_gub2ul5"));
                    ps.setObject(13,dataList.get(i).get("numberField_hqiac12"));
                    ps.setObject(14,dataList.get(i).get("numberField_lz6mt3xq"));
                    double grossProfit = dataList.get(i).get("numberField_lz6mt3xq")==null?0f:Double.parseDouble(dataList.get(i).get("numberField_lz6mt3xq").toString());
                    double income = dataList.get(i).get("numberField_zjdki9k")==null?0f:Double.parseDouble(dataList.get(i).get("numberField_zjdki9k").toString());
                    grossProfit = grossProfit/income;
                    if (income == 0f){
                        grossProfit = 0f;
                    }
                    ps.setObject(15,df.format(grossProfit));
                    ps.setObject(16,dataList.get(i).get("numberField_ln701sy"));
                    ps.setObject(17,dataList.get(i).get("numberField_fmhzxdr"));
                    ps.setObject(18,dataList.get(i).get("numberField_lz6mt3xr"));
                    double net = ObjectUtil.isNotNull(dataList.get(i).get("numberField_lz6mt3xr"))?Double.parseDouble(dataList.get(i).get("numberField_lz6mt3xr").toString()):0f;
                    double net_margin = net/income;
                    if (income == 0f){
                        net_margin = 0f;
                    }
                    ps.setObject(19,df.format(net_margin));
                    ps.setObject(20,dataList.get(i).get("textField_tpb3m2f"));
                    ps.setObject(21,dataList.get(i).get("textField_2adicsn"));
                    String profit_loss = "";
                    if (net_margin < 0){
                        profit_loss = "亏损";
                    }else if (net_margin >=0 && net_margin <=0.05){
                        profit_loss = "净利较低";
                    }else if(net_margin > 0.05){
                        profit_loss = "盈利";
                    }
                    ps.setObject(22,dataList.get(i).get("textField_1yw4mx4") == null ? null : profit_loss);
                    ps.setObject(23,dataList.get(i).get("dateField_ji5yfvf"));
                    ps.setObject(24,dataList.get(i).get("textField_h2qx5nz"));
                    ps.setObject(25,dataList.get(i).get("textField_35paoph"));
                    ps.addBatch();
                    if (i%500==0){
                        ps.executeBatch();
                        ps.clearBatch();
                    }
                }
                ps.executeBatch();
                connection.close();
            } catch (Exception exception) {
                throw new RuntimeException(exception);
            }
            dataList.forEach(e->{
                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(UtilMap.getString(e, "formInstanceId"))
//                    .useLatestVersion(true)
//                    .updateFormDataJson(JSONObject.toJSONString(new HashMap<>()))
                        .updateFormDataJson(JSON.toJSONString(UtilMap.map("radioField_m0dkcxod", "是")))
                        .build(), YDConf.FORM_OPERATION.update);
            });
        }
    }
    /**
     * 日常物耗申请单中采购专员审批后更新字段初始物耗费用总计
     * @param
     */
    @Override
    public void updateMaterialConsumption(String formInstId,Double firstCost,Double nowCost) {
        log.info("初始物耗费用合计为：{}",firstCost);
        if(ObjectUtil.isEmpty(firstCost) || firstCost == 0.0){
            log.info("流程id为：{}",formInstId);
            log.info("初始物耗费用合计为：{}",firstCost);
            log.info("本次物耗费用合计为：{}",nowCost);
            ydClient.operateData(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formInstanceId(formInstId)
                    .updateFormDataJson(JSON.toJSONString(UtilMap.map("numberField_m0xizy3q", nowCost)))
                    .build(), YDConf.FORM_OPERATION.update);
        }
    }


    /**
     * 应收款通知：
     * 	每月10日，拉取上月底之前开票档案，已开未有任何回款数据。按照客户纬度汇总生成催款单据
     *  - 只要有已回款，则不在通知
     *  - 红字发票不需要通知
     */
    @Override
    public void sendReminderLetter() {

        List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                .formUuid("FORM-6603375ED27B4D059CBB919C2BEFA44BZVOL")
                .searchCondition(JSON.toJSONString(UtilMap.map("radioField_m06hhw2p, selectField_lvituew9", "未回款", "正常")))
                .build());

        // 数据字典
        UtilMap.map("大业主, 小业主, 工程订单, 日保一次性",
                UtilMap.map("table, content", "tableField_lvc9x4vt, textField_lvd8pp2t"),
                UtilMap.map("table, content", "tableField_lvd8pp44, textField_lvd8pp3w"),
                UtilMap.map("table, content", "tableField_lvdnme13, textField_lvdnme0u")
        );
        // 按照客户维度
        dataList.forEach(e -> {

            String type = UtilMap.getString(e, "selectField_lvc9x4vn");


            String invoiceNo = UtilMap.getString(e, "textField_m06ij3z9");
            String invoiceDate = UtilMap.getString(e, "dateField_m06ij3zc");
            String amount = UtilMap.getString(e, "numberField_m06ij3zf");
            String customerName = UtilMap.getString(e, "textField_m06ij3z8");
        });

    }

    @Override
    public void freshVersion(Map<String, Object> data) {
        if (data.size()>0){
            String type = data.get("type").toString();
            String id = data.get("id").toString();
            if (type.equals("表单ID")){
                List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid(id)
                        .build());
                log.info("小业主档案_测试, {}", dataList.toString());
                dataList.forEach(e -> {
                    ydClient.operateData(YDParam.builder()
                            .appType("APP_ERBDTFS82HOVBPL3NFH0")
                            .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                            .formInstanceId(UtilMap.getString(e, "formInstanceId"))
                            .useLatestVersion(true)
                            .updateFormDataJson(JSON.toJSONString(new HashMap<>()))
                            .build(), YDConf.FORM_OPERATION.update);
                });
            } else if (type.equals("实例ID")) {
                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(id)
                        .useLatestVersion(true)
                        .updateFormDataJson(JSON.toJSONString(new HashMap<>()))
                        .build(), YDConf.FORM_OPERATION.update);
            }
        }
    }

    @Override
    public void updateMaterialProject(String projectCode, String date, Double firstCost, Double nowCost, String formInstId) {
        if(ObjectUtil.isEmpty(firstCost) || firstCost == 0.0){
            List<Map> bigList = ydService.queryFormData_all(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                    //测试档案
//                    .formUuid("FORM-D3F341E3315140F4ADC9E5005260309E8B27")
                    .searchFieldJson(JSON.toJSONString(UtilMap.map("textField_ltxrn8h1", projectCode)))
                    .build());
            bigList.forEach(e->{
                List<Map> sonList = (List<Map>) e.get("tableField_lrru2tnq");
                if (ObjectUtil.isNotEmpty(sonList)){
                    sonList.forEach(s->{
                        //年月文本
                        String projectDate = s.get("textField_luh0k82j").toString();
                        if (date.equals(projectDate)){
                            //剩余物耗定额
                            double remaining = s.get("numberField_lrru2tnv_value") == null?0f:Double.parseDouble(s.get("numberField_lrru2tnv_value").toString());
                            //已用物耗定额
                            double used = s.get("numberField_ludujw4f_value") == null?0f:Double.parseDouble(s.get("numberField_ludujw4f_value").toString());
                            remaining = remaining - nowCost;
                            s.put("numberField_lrru2tnv",remaining);
                            used = used + nowCost;
                            s.put("numberField_ludujw4f",used);
                        }
                    });
                }
                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(e.get("formInstanceId").toString())
//                    .useLatestVersion(true)
                        .updateFormDataJson(JSON.toJSONString(UtilMap.map("tableField_lrru2tnq", sonList)))
                        .build(), YDConf.FORM_OPERATION.update);
            });
            log.info("日常物耗流程id为：{}",formInstId);
            log.info("初始物耗费用合计为：{}",firstCost);
            log.info("本次物耗费用合计为：{}",nowCost);
            ydClient.operateData(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formInstanceId(formInstId)
                    //更新初始物耗总计
                    .updateFormDataJson(JSON.toJSONString(UtilMap.map("numberField_m0xizy3q", nowCost)))
                    .build(), YDConf.FORM_OPERATION.update);
        }
    }


    @Override
    public void projectUnshipped() {
        List<Map> allProjectList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
//                .searchFieldJson(JSON.toJSONString(UtilMap.map("selectField_lrn2oy4a","进行中")))
                .build());
        //有库存的非无需出库项目
        List<Map> materialList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-38649DA9003B48F4A7DC476122E4D6C1JNKU")
                .build());
        List<Map<String,Object>> result = new ArrayList<>();
        Map<String, List<Map>> codeList = materialList.stream().collect(Collectors.groupingBy(map -> map.get("textField_ltxutdfi").toString()));
        codeList.forEach((k,sList)->{
            Map<String, Object> hashMap = new HashMap<>();
            IntSummaryStatistics sum = sList.stream().collect(Collectors.summarizingInt(e -> parseInt(e.get("numberField_lu24bwd0").toString())));
            if (sum.getSum() > 0){
                hashMap.put("code",sList.get(0).get("textField_ltxutdfi"));
                hashMap.put("sum",sum.getSum());
                result.add(hashMap);
            }
        });
        //本周已出库项目
        long beginWeek = DateUtil.beginOfWeek(DateUtil.date()).getTime();
        long endWeek = DateUtil.endOfWeek(DateUtil.date()).getTime();
        String[] dateList = new String[2];
        dateList[0] = String.valueOf(beginWeek);
        dateList[1] = String.valueOf(endWeek);
        List<Map> alredyList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-38649DA9003B48F4A7DC476122E4D6C1JNKU")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("dateField_lvvthng6", (Object) dateList)))
                .build());
        if (alredyList.size()>0 && ObjectUtil.isNotNull(alredyList)){
            alredyList = alredyList.stream().collect(Collectors.collectingAndThen(Collectors.toCollection(() ->
                    new TreeSet<>(Comparator.comparing(o-> o.get("textField_ltxutdfi").toString()))), ArrayList::new));

            for (Map<String, Object> stringObjectMap : result) {
                int status = 1;
                for (Map value : alredyList) {
                    if (stringObjectMap.get("code").equals(value.get("textField_ltxutdfi"))) {
                        status = 0;
                        break;
                    }
                }

                for (Map map : allProjectList) {
                    if (stringObjectMap.get("code").equals(map.get("textField_ltxrn8h1"))) {
                        if ("进行中".equals(map.get("selectField_lrn2oy4a"))){
                            ydClient.operateData(YDParam.builder()
                                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                                    .formInstanceId(map.get("formInstanceId").toString())
                                    .updateFormDataJson(JSON.toJSONString(UtilMap.map("numberField_m230rjg5", status)))
                                    .build(), YDConf.FORM_OPERATION.update);
                        }
                        else {
                            ydClient.operateData(YDParam.builder()
                                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                                    .formInstanceId(map.get("formInstanceId").toString())
                                    .updateFormDataJson(JSON.toJSONString(UtilMap.map("numberField_m230rjg5", 0)))
                                    .build(), YDConf.FORM_OPERATION.update);
                        }
                        break;
                    }
                }
            }
        }
    }

    @Override
    public void monthPersonnelMatters() {

        Date date = DateUtil.date();
        Date beginOfMonth = DateUtil.beginOfMonth(date);
        String[] dateList = new String[2];
        dateList[0] = String.valueOf(beginOfMonth.getTime());
        dateList[1] = String.valueOf(date.getTime());
//        List<Map> materialList = ydService.queryFormData_all(YDParam.builder()
//                .appType("APP_ERBDTFS82HOVBPL3NFH0")
//                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
//                .formUuid("FORM-4F7FB29798F442E783B1C77AF1E7D644FBI7")
//                .searchFieldJson(JSON.toJSONString(UtilMap.map("dateField_lzhqum4c", (Object) dateList)))
//                .build());
//        if (ObjectUtil.isNotNull(materialList)&&materialList.size()>0){
//            materialList.forEach(e->{
//                ydClient.operateData(YDParam.builder()
//                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
//                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
//                        .formInstanceId(e.get("formInstanceId").toString())
//                        .build(), YDConf.FORM_OPERATION.delete);
//            });
//        }

        //获取所有离职员工id
        String dingtalkToken = ddClient.getAccessToken(dingtalkAppKey, dingtalkAppSecret);
        List<String> leaveIdList = ddClientPersonnel.getLeaveEmployeeIdList(dingtalkToken);
        //获取当前在职人员id
        String status = "2,3,5,-1";
        List<String> employeeIds = ddClientPersonnel.getWorkingEmployeeIds(ddClient.getAccessToken(), status);
        //第一个元素为本月入职人数
        final int[] month = {0,0};
        List<String> filterList = new ArrayList<>();
        Set<String> inJobIdSet = new HashSet<>();
        List<String> inJobIds = new ArrayList<>();
        inJobIds.addAll(employeeIds);
        inJobIds.addAll(leaveIdList);
        //现合同起始日
        filterList.add("sys05-nowContractStartTime");
        //现合同到期日
        filterList.add("sys05-nowContractEndTime");
        //入职时间
        filterList.add("sys00-confirmJoinTime");
        //获取待入职人员id列表
//        List<String> pendingIds = ddClientPersonnel.getPendingEmployeeIds(ddClient.getAccessToken());
        //根据在职人员id和离职人员id列表获取花名册信息
        List<Map> employeeInfos = ddClientPersonnel.getEmployeeInfos(ddClient.getAccessToken(), inJobIds, agentId, filterList);
        System.out.println(employeeInfos);
        employeeInfos.forEach(e->{
            if (ObjectUtil.isNotNull(e.get("field_data_list"))){
                List<Map> userData = (List<Map>) e.get("field_data_list");
                userData.forEach(f->{
                    if ("sys00-confirmJoinTime".equals(f.get("field_code"))){
                        List<Map> dataValue = (List<Map>) f.get("field_value_list");
                        if (ObjectUtil.isNotNull(dataValue.get(0).get("value"))){
                            Date value = DateUtil.parse(dataValue.get(0).get("value").toString());
//                            if (dataValue.get(0).get("value").toString().substring(0,7).equals("2024-09")){
                            if (DateUtil.compare(value,beginOfMonth)>=0 && DateUtil.compare(date,value)>=0){
//                                month[0]++;
                                inJobIdSet.add(e.get("userid").toString());
//                                }
                            }
                        }
                    }
                });
            }
        });

        //根据员工id获取员工信息，过滤当前时间到本月初的人员
        if (ObjectUtil.isNotNull(leaveIdList)&&leaveIdList.size()>0){
            List<Map> leaveInfos = ddClientPersonnel.getLeaveEmployeeInfos(dingtalkToken, leaveIdList);
            if (ObjectUtil.isNotNull(leaveInfos) && leaveInfos.size()>0){
                leaveInfos.forEach(e->{
                    if (ObjectUtil.isNotNull(e.get("lastWorkDay"))){
                        long lastWorkTime = Long.parseLong(e.get("lastWorkDay").toString());
                        Date lastWorkDate = DateUtil.date(lastWorkTime);
                        if (ObjectUtil.isNotEmpty(lastWorkDate) && DateUtil.compare(lastWorkDate,beginOfMonth)>=0 && DateUtil.compare(date,lastWorkDate)>=0){
                            month[1] += 1;
                        }
                    }
                });
            }
        }
//
        ydClient.operateData(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-4F7FB29798F442E783B1C77AF1E7D644FBI7")
                .searchCondition(JSON.toJSONString(UtilMap.map("dateField_lzhqum4c", (Object) dateList)))
                //年月，离职人数，入职人数，在职人数
                .formDataJson(JSON.toJSONString(UtilMap.map("dateField_lzhqum4c, numberField_lzhqum4e, numberField_lzhqum4f, numberField_lzhqum4d",beginOfMonth.getTime(),month[1],inJobIdSet.size(),employeeIds.size())))
                .build(), YDConf.FORM_OPERATION.upsert);
    }

    @Override
    public void updateIsSupply(Map data) {
//        Map params = request.getParameterMap();
//        String[] strings = (String[]) params.get("formInstId");
        String formInstId = data.get("formInstId").toString();
        log.info("formInstId:{}",formInstId);
        try {
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        ydClient.operateData(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formInstanceId(formInstId)
                .updateFormDataJson(JSON.toJSONString(UtilMap.map("radioField_m38dy26d","是")))
                .build(), YDConf.FORM_OPERATION.update);
    }

    @Override
    public Map<String, Boolean> selectIsSupply(String projectCode) {
//        Map params = request.getParameterMap();
//        String[] strings = (String[]) params.get("projectCode");
        List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("textField_lrr3rg6h", projectCode)))
                .build());
        Map<String, Boolean> map = new HashMap<>();
        map.put("success",true);
        if (ObjectUtil.isNotNull(dataList)){
            for (int i = 0; i < dataList.size(); i++) {
                String isSupply = dataList.get(i).get("radioField_m38dy26d") == null?"":dataList.get(i).get("radioField_m38dy26d").toString();
                if ("否".equals(isSupply)||"".equals(isSupply)){
                    map.put("success",false);
                }
            }
        }
        return map;
    }

    @Override
    public Map<String, Boolean> testSelectIsSupply(HttpServletRequest request) {
        Map<String, Boolean> map = new HashMap<>();
        map.put("success",true);
        return map;
    }

    @Override
    public void updateAnalysis(Map<String,Object> map) {
        YDParam ydParam = YDParam.builder()
                .formInstId(map.get("formInstId").toString())
                .build();
        Map data = ydClient.queryData(ydParam, YDConf.FORM_QUERY.retrieve_id).getFormData();
        log.info("修改数据:{}",data);
        try {
            Class.forName(driver);
            Connection connection = DriverManager.getConnection(url, username, password);
            String updateSql = "UPDATE `lanyun_project_analysis` SET  `belong_project` = '"+ data.get("textField_bheotm5")+"', " +
                    " `status` = '"+ data.get("textField_pa6o780")+"', `predict_income` = '"+ data.get("numberField_5wyyb42")+"', `open` = '"+ data.get("numberField_c4acnrg")+"', " +
                    "`income` = '"+ data.get("numberField_zjdki9k")+"', `person` = '"+ data.get("numberField_hg6jznm")+"', `person_cost` = '"+ data.get("numberField_7ga9c5w")+"', " +
                    "`material` = '"+ data.get("numberField_c3cqsfv")+"', `other_cost` = '"+ data.get("numberField_avaexyf")+"', " +
                    "`cost_sum` = '"+ data.get("numberField_gub2ul5")+"', `taxes` = '"+ data.get("numberField_hqiac12")+"', `gross_profit` = '"+ data.get("numberField_lz6mt3xq")+"', " +
                    "`gross_margin` = '"+ data.get("numberField_lz9n3fm9")+"', " +
                    "`overhead` = '"+ data.get("numberField_ln701sy")+"', `corporate_income_tax` = '"+ data.get("numberField_fmhzxdr")+"', " +
                    "`net_profit` = '"+ data.get("numberField_lz6mt3xr")+"', `net_margin` = '"+ data.get("numberField_lz9n3fma")+"', " +
                    "`format` = '"+ data.get("textField_tpb3m2f")+"', `customer_system` = '"+ data.get("textField_2adicsn")+"', `profit_loss` = '"+ data.get("textField_1yw4mx4")+"', " +
                    "`approach_date` = '"+ data.get("dateField_ji5yfvf")+"', " +
                    "`level` = '"+ data.get("textField_h2qx5nz")+"', `notes` = '"+ data.get("textField_35paoph")+"'" +
                    " WHERE `project_name` = '"+ data.get("textField_dliiyul")+"' AND `month` = "+data.get("dateField_lcwv382")+";\n";
            PreparedStatement ps = connection.prepareStatement(updateSql);
            ps.executeUpdate();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public List<Map> checkoutStatus(Map<String, Object> data) {
        List<Map> lastResult = new ArrayList<>();
        List<Map> allProjectList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("selectField_lrn2oy4a","进行中")))
                .build());
        //有库存的非无需出库项目
        List<Map> materialList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-38649DA9003B48F4A7DC476122E4D6C1JNKU")
                .build());
        List<Map<String,Object>> result = new ArrayList<>();
        Map<String, List<Map>> codeList = materialList.stream().collect(Collectors.groupingBy(map -> map.get("textField_ltxutdfi").toString()));
        codeList.forEach((k,sList)->{
            Map<String, Object> hashMap = new HashMap<>();
            IntSummaryStatistics sum = sList.stream().collect(Collectors.summarizingInt(e -> parseInt(e.get("numberField_lu24bwd0").toString())));
            if (sum.getSum() > 0){
                hashMap.put("code",sList.get(0).get("textField_ltxutdfi"));
                hashMap.put("sum",sum.getSum());
                result.add(hashMap);
            }
        });
        //本周已出库项目
//        long beginWeek = DateUtil.beginOfWeek(DateUtil.date()).getTime();
//        long endWeek = DateUtil.endOfWeek(DateUtil.date()).getTime();
        String startDate = data.get("startDate").toString();
        String endDate = data.get("endDate").toString();
        String[] dateList = new String[2];
        dateList[0] = String.valueOf(startDate);
        dateList[1] = String.valueOf(endDate);
        List<Map> alredyList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid("FORM-38649DA9003B48F4A7DC476122E4D6C1JNKU")
                .searchFieldJson(JSON.toJSONString(UtilMap.map("dateField_lvvthng6", (Object) dateList)))
                .build());
        ArrayList<String> codes = new ArrayList<>();
        for (Map<String, Object> stringObjectMap : result) {
            int status = 1;
            if (alredyList.size()>0 && ObjectUtil.isNotNull(alredyList)){
                alredyList = alredyList.stream().collect(Collectors.collectingAndThen(Collectors.toCollection(() ->
                        new TreeSet<>(Comparator.comparing(o-> o.get("textField_ltxutdfi").toString()))), ArrayList::new));
                for (Map value : alredyList) {
                    if (stringObjectMap.get("code").equals(value.get("textField_ltxutdfi"))) {
                        status = 0;
                        break;
                    }
                }
            }
            if (status == 1 && ObjectUtil.isNotNull(allProjectList)){
                for (Map map : allProjectList) {
                    if (stringObjectMap.get("code").equals(map.get("textField_ltxrn8h1")) && "进行中".equals(map.get("selectField_lrn2oy4a"))) {
                        codes.add(stringObjectMap.get("code").toString());
                        break;
                    }
                }
            }
        }
        for (int i = 0; i < materialList.size(); i++) {
//            HashMap<Object, Object> lastMap = new HashMap<>();
//            lastMap.put("code",materialList.get(i).get("textField_ltxutdfi"));
//            lastMap.put("name",materialList.get(i).get("textField_lvat5hwb"));
//            lastMap.put("entryDate",materialList.get(i).get("dateField_lvvthng6"));
//            lastMap.put("whcode",materialList.get(i).get("textField_lr26l3hs"));
//            lastMap.put("whmc",materialList.get(i).get("textField_lr26l3ht"));
//            lastMap.put("whfl",materialList.get(i).get("textField_lu24bwd1"));
//            lastMap.put("salary",materialList.get(i).get("numberField_lu24bwd0"));
            for (int j = 0; j < codes.size(); j++) {
                if (materialList.get(i).get("textField_ltxutdfi").equals(codes.get(j))){
                    lastResult.add(materialList.get(i));
//                    lastResult.add(lastMap);
                    break;
                }
            }
        }
        return lastResult;
    }

    @Override
    public void updateDailyPrice(String formInstId) {

        System.out.println(formInstId);
        Map formData = ydClient.queryData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstId(formInstId).build()
                , YDConf.FORM_QUERY.retrieve_id).getFormData();
        System.out.println(formData);
        if (ObjectUtil.isNotNull(formData)){
            String area = ObjectUtil.isNotNull(formData.get("selectField_lrn2oy4b"))?formData.get("selectField_lrn2oy4b").toString():"";
            List<Map> sonList = (List<Map>) formData.get("tableField_lr383i4g");
            double sum[] = {0,0};
            if (ObjectUtil.isNotNull(sonList) && sonList.size()>0){
                sonList.forEach(e->{
                    String code = e.get("textField_lr383i4h").toString();
                    if (ObjectUtil.isNotNull(code)){
                        List<Map> businessList = ydService.queryFormData_all(YDParam.builder()
                                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                                .formUuid("FORM-84AFCA01E1C24216BD46DC13FB3A82D4B4ZB")
                                .searchFieldJson(JSON.toJSONString(UtilMap.map("textField_ltxqbvzu, selectField_ltxy8wyr, selectField_ltxqfrj8", code,"启用",area)))
                                .build());
                            if (businessList.size()>=2){
                                businessList = businessList.stream().filter(map -> map.get("textField_ludp2v7i") != "临时采购").collect(Collectors.toList());
                            }
                        System.out.println(businessList.size());
                        if(ObjectUtil.isNotNull(businessList)){
                            if (ObjectUtil.isNotNull(businessList.get(0).get("numberField_ltxqbvzz"))){
                                double fax = Double.parseDouble(businessList.get(0).get("numberField_ltxqbw00").toString());//税率
                                e.put("numberField_ludq7er6",fax);
                                Double unitPrice = Double.parseDouble(businessList.get(0).get("numberField_ltxqbvzz").toString());//供应商价目
                                e.put("numberField_ludokwa6",unitPrice);
                                e.put("selectField_lv4tq48o",businessList.get(0).get("selectField_ltxqfrj8") + "区 ￥" + businessList.get(0).get("numberField_ltxqbvzz") + " " + businessList.get(0).get("textField_ludp2v7i"));
                                Double scbqr = Double.parseDouble(e.get("numberField_lvaft823").toString());//市场部确认
                                e.put("numberField_lxd0y351",String.format("%.8f", scbqr * unitPrice));//实际金额小计
                                sum[0] = sum[0] + scbqr * unitPrice;
                                e.put("numberField_lrzu5n7d",String.format("%.2f",unitPrice * 1.1));//采购单价
                                e.put("numberField_ludokwa9",String.format("%.2f", unitPrice * 1.1 * scbqr));//采购金额小计
                                sum[1] = sum[1] + scbqr * unitPrice * 1.1;
                                e.put("numberField_lv1qokdj",String.format("%.2f", unitPrice/(1+fax/100)));
                            }
                        }
                    }
                });
                System.out.println(sum);
                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(formInstId)
                        .updateFormDataJson(JSON.toJSONString(UtilMap.map("numberField_lwk4dwfe, numberField_lr383i48, tableField_lr383i4g",String.format("%.2f", sum[0]),String.format("%.2f", sum[1]),sonList)))
                        .build(), YDConf.FORM_OPERATION.update);
            }
        }
    }
}
//实际金额小计
//numberField_lwk4dwfe
//采购金额小计
//numberField_lr383i48